/*
	TODO: before logged in, `help` must only show `register, login, version`
*/

HISTORY_FILE ∆ '~/.netiety/history'
≣'config'
repl ∆≣ 'jrepl/jrepl'
jsock ∆≣ 'jsocket/client'
nyuser ∆≣ 'ny.user/client'
jgirl ∆≣ 'jgirl'
≣ 'repl-honor'
≣ 'config-dir'
init_config_dir()

nyuser.init(repl.commands)
talk ∆ jsock.talk
news ∆ []
argv = __args([], [@history])
❰argv.history❱
	HISTORY_FILE = ≣('os').homedir()+'/.netiety/history_' + argv.history
	❰fs.existsSync(HISTORY_FILE)❱
			ロ 'Using existing custom history file.'
	◇
		try {
			⛃(HISTORY_FILE, '')
			ロ 'Created custom history file.'
		} catch (e) {
			ロ 'Unable to create ' HISTORY_FILE
			⚑
		}
		⁋
	⁋

repl.post_command = ➮ {
	❰news↥ > 0❱
		ロ 'News: ' news↥
		⁋
}

➮ repl_news0 ctx args f {
	❰news↥ > 0❱ ロ news ⬉
	f()
}

➮ repl_news ctx args f {
	⧖news↥ > 0
		ロ news ⬉
	f()
}

➮ repl_test ctx args f0 {
	talk(ctx.socket, {id:'test'}, ➮ - ctx msg f {
		❰msg.test❱
			ロ msg.test
		◇
			ロ msg.msg
			⁋
		f0()
	})
}

➮ mail ctx msg f {
	news ⬊ ('mail: ' +ꗌmsg+ '')
	f({ msg:'whatever' }, ➮ {
		news ⬊ 'Ping acceptor'
	})
}

➮ socket_error ctx { }

➮ socket_connect ctx {
	ロ 'Connected to server at '+ config.host +':' + config.port
	batch ∆ []
	try {
		batch = ⛁(≣('os').homedir() + '/.netiety/start') ≂⌶'\n'
		batch = batch ꔬ (➮{ $ a⁰ ≠ '#' })
	} catch(em) {
	}
	➮ next {
		❰batch↥ > 0❱
			cmd ∆ batch ⬉
			cmd = cmd.trim()
			❰cmd↥ ≟ 0❱
				next()
			◇
				repl.exec(ctx, cmd, next)
				⁋
		◇
			repl.start(ctx, HISTORY_FILE)
			⁋
	}
	next()
	$
	talk(ctx.socket, {id:'version'}, ➮ - ctx msg f {
		ロ 'version:', msg.version
		f({ok:'ok'})
		repl.start(ctx, HISTORY_FILE)
	})
}

➮ socket_close ctx { ロ '\nLost connection to server, have to exit.'; ⚑ }

➮ format_help help {
	➮ wrap W a {
		a = elfu_rtl.repl(a, '\t', '   ')
		a = a ⌶ '\n'
		i ► a i = wrap_para(W, i)
		$ a ⫴ '\n'
	}
	
	➮ line_width {
		sum ∆ 0
		i ► a  sum += i↥
		$ sum + a↥ - 1
	}

	➮ wrap_para W para {
		para = para ⌶ ' '
		init ∆ '  '
		para ⬋ init
		R ∆ []  line ∆ []
		word ► para {
			❰line_width(line) < W - word↥ + 1❱
				//❰line↥ > init↥❱ 
				//❰❱ line += ' '
				line ⬊ word
				//line += '' + word
			◇
				R ⬊ (line ⫴ ' ')
				line = [word]
				⁋
		}
		R ⬊ (line ⫴ ' ')
		$ R ⫴ '\n'
	}

	K ∆ ⚷ help
	k ► K  helpᵏ = wrap(65, helpᵏ)
}

➮ assign_commands ctx {

//$ help-version --- 7
repl.help.version = '''
Show version
'''
//$ help-basic --- 7
repl.help.basic = '''
Netiety.com client console.
Type "quit" (or also press Control+D on Linux) to quit.
This console supports TAB-completion.
Commands are in JGIRL format.
'''
//$ help-basic --- 7
repl.help.jgirl = '''
JGIRL. A simple parser of arguments for Netiety.

If a command help shows something like this:

	label <label> <doc>

And the label is named "like" and the doc is "book", you can type the command like this:

	label like book

Or use names of the arguments:

	label doc=book label=like

Or use shortcuts:

	label l=like d=book

If the argument needs a space, use the dash instead:

	label like Very-good-book

Dashes will be converted to spaces. To add a dash use a double dash.

	label travel Far--East.

Alternatively you can enclose the values in single quotes, in this case the argument name must be present. (to be implemented)

	label travel doc='Far East'
'''

	repl.commands.version = ➮ repl_version ctx args f0 {
		package ∆ ≣ (__dirname + '/package.json')
		J ∆ jgirl.from(args ⫴ ' ')
		ロ 'Client version: ' package.version
		talk(ctx.socket, {id:'version'}, ➮ - ctx args f {
			ロ 'Server version:', args.version
			f0()
		})
	}
	
	repl.commands.test = repl_test
	repl.commands.news = repl_news
	assign_repl_honor(repl, ctx, jgirl, talk)
	format_help(repl.help)
	
	repl.commands[''] = repl_news0

} // ➮ assign_commands

➮ main {
	ctx ∆ { on: { mail:mail } }
	assign_commands(ctx)
	jsock.connect(config.host, config.port, ctx, socket_error, socket_connect, socket_close)
}

main()



